#include <QFile>
#include <QTextCodec>
#include <QTextStream>
#include "a2BCdatFileChecker.h"
#include "a2BCsubjectParser.h"

/*!
 *  RXgN^
 * 
 */
a2BCdatFileChecker::a2BCdatFileChecker(QWidget *parent)
 : QWidget(parent)
{
    resetData();
}

/*!
 *  fXgN^
 * 
 */
a2BCdatFileChecker::~a2BCdatFileChecker()
{
    resetData();
}


/*!
 * 
 * 
 * 
 */
void a2BCdatFileChecker::resetData(void)
{
    mDatFileTitle.clear();
    mDatFileName.clear();
    mPath.clear();    
    return;
}

/*!
 *  f[^t@Cݒ肷
 * 
 */
void a2BCdatFileChecker::appendDataFile(const QString &arPath, const QString &arDatFileName)
{
    QString title = pickupDatFileTitle(arPath, arDatFileName);

    mDatFileTitle.append(title);
    mDatFileName.append(arDatFileName);
    mPath.append(arPath);

}

/*!
 * 
 * 
 */
void a2BCdatFileChecker::outputDataFile(QString &arPath, QTextStream *apStream)
{
    int limit = mDatFileName.size();
    for (int index = 0; index < limit; index++)
    {
        if (mPath[index] == arPath)
        {
            (*apStream) << mDatFileName[index] << ",0,1,6,0,0," << mDatFileTitle[index] << endl;
        }
    }
    return;
}

/*!
 * 
 * 
 */
void a2BCdatFileChecker::appendSubjectTxtFile(QString &arPath, a2BCsubjectParser *apParser)
{
    if (apParser->isPrepare() != true)
    {
        return;
    }

    int limit = mDatFileName.size();
    for (int index = 0; index < limit; index++)
    {
        if (mPath[index] == arPath)
        {
            if (apParser->exist(mDatFileName[index]) == false)
            {
                //
                apParser->appendData(mDatFileName[index], mDatFileTitle[index]);
            }
        }
    }
    return;
}

/*!
 *  t@CX^Cgo
 * 
 */
QString a2BCdatFileChecker::pickupDatFileTitle(const QString &arPath, const QString &arFileName)
{
    QFile datFile(arPath + "/" + arFileName);
    if (!datFile.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        return (arFileName);
    }

    QTextCodec  *codec = QTextCodec::codecForName("Shift-JIS");
    QTextStream in(&datFile);
    in.setCodec(codec);
    QString line = in.readLine();
    datFile.close();
    if (line.isEmpty())
    {
        return (arFileName);
    }
    int     pos = line.lastIndexOf("<>");
    if (pos < 0)
    {
        return (arFileName);
    }
    return (line.mid((pos + 2)));    
}

/*
 *  a2BC : a2B Connectivity
 *  Copyright (C) 2006- NNsi Project
 *  (see a2BC-src.txt for detail.)
 */
